//CAPY - timeglass

// Tidsintervall regnes ut basert på et satt klokkeslett (kl 22:00)
const int potStaaOpp = A0;
const int potTimerSovn = A1;

const int antLysrekker = 8;
int potValStaaOpp;
int potValTimerSovn;

int antTimerSovn;
int tidStaaOpp;
int tidLeggeSeg;

long tidsInterval = 0;

long intervaller[8];

void setup() 
{
  Serial.begin(9600);
  
  for(int x = 8; x > 0; x--)
  {
    pinMode(x, OUTPUT);
  }
  
}

void loop() 
{
  hentInput();
  
  unsigned long naavaerendeTid = millis();
  Serial.print("tidsintervall: ");
  Serial.print(tidsInterval);

  if(naavaerendeTid < intervaller[0] || tidsInterval == 0)
  {
    // Alle de rød radene er avskrudd
    for(int i = 5; i < 9; i--)
    {
      digitalWrite(i, LOW);
    }
    
    // Alle de grønne radene er påskrudd
    for(int i = 1; i < 5; i++)
    {
      digitalWrite(i, HIGH);
    }
    
  }
  else if(naavaerendeTid > intervaller[0] && naavaerendeTid < intervaller[1])
  {
    // Alle de rød radene, og den øverste grønne, er avskrudd
    for(int i = 4; i < 9; i--)
    {
      digitalWrite(i, LOW);
    }
    
    // Alle, utenom den øverste, grønne radene er påskrudd
    for(int i = 1; i < 4; i++)
    {
      digitalWrite(i, HIGH);
    }
    
  }
  else if(naavaerendeTid > intervaller[1] && naavaerendeTid < intervaller[2])
  {
     digitalWrite(8, LOW);
     digitalWrite(7, LOW);
     digitalWrite(6, LOW);
     digitalWrite(5, HIGH);
     digitalWrite(4, LOW);
     digitalWrite(3, HIGH);
     digitalWrite(2, HIGH);
     digitalWrite(1, HIGH);
     
     
  }
  else if(naavaerendeTid > intervaller[2] && naavaerendeTid < intervaller[3])
  {
    digitalWrite(8, LOW);
     digitalWrite(7, LOW);
     digitalWrite(6, LOW);
     digitalWrite(5, HIGH);
     digitalWrite(4, LOW);
     digitalWrite(3, LOW);
     digitalWrite(2, HIGH);
     digitalWrite(1, HIGH);
     
  }
  else if(naavaerendeTid > intervaller[3] && naavaerendeTid < intervaller[4])
  {    
     digitalWrite(8, LOW);
     digitalWrite(7, LOW);
     digitalWrite(6, HIGH);
     digitalWrite(5, HIGH);
     digitalWrite(4, LOW);
     digitalWrite(3, LOW);
     digitalWrite(2, HIGH);
     digitalWrite(1, HIGH);
  }
  else if(naavaerendeTid > intervaller[4] && naavaerendeTid < intervaller[5])
  {
     digitalWrite(8, LOW);
     digitalWrite(7, LOW);
     digitalWrite(6, HIGH);
     digitalWrite(5, HIGH);
     digitalWrite(4, LOW);
     digitalWrite(3, LOW);
     digitalWrite(2, LOW);
     digitalWrite(1, HIGH);
  }
  else if(naavaerendeTid > intervaller[5] && naavaerendeTid < intervaller[6])
  {
     digitalWrite(8, LOW);
     digitalWrite(7, HIGH);
     digitalWrite(6, HIGH);
     digitalWrite(5, HIGH);
     digitalWrite(4, LOW);
     digitalWrite(3, LOW);
     digitalWrite(2, LOW);
     digitalWrite(1, HIGH);
  }
  else if(naavaerendeTid > intervaller[6] && naavaerendeTid < intervaller[7])
  {
     digitalWrite(8, LOW);
     digitalWrite(7, HIGH);
     digitalWrite(6, HIGH);
     digitalWrite(5, HIGH);
     digitalWrite(4, LOW);
     digitalWrite(3, LOW);
     digitalWrite(2, LOW);
     digitalWrite(1, LOW);
  }
  else if(naavaerendeTid == intervaller[7])
  {
      // Alle de rød radene er påskrudd
    for(int i = 5; i < 9; i--)
    {
      digitalWrite(i, HIGH);
    }
    
    // Alle de grønne radene er avskrudd
    for(int i = 1; i < 5; i++)
    {
      digitalWrite(i, LOW);
    }
  }

  
}

void hentInput()
{
  potValStaaOpp = analogRead(potStaaOpp);
  potValTimerSovn = analogRead(potTimerSovn);

  // 24 timers-klokke - brukeren kan stå opp når på døgnet hen ønsker
  int mappedValStaaOpp = map(potValStaaOpp, 0,1023, 0,24);

  // Vi har satt en begrensning på 12 timer søvn
  int mappedValTimerSovn = map(potValTimerSovn, 0,1023, 0,12);

  
  // Henter input fra brukeren antTimerSovn
  antTimerSovn = mappedValTimerSovn;

 
  // Henter input fra brukeren tidStaaOpp
 tidStaaOpp = mappedValStaaOpp;



 tidLeggeSeg = tidStaaOpp - antTimerSovn;
 

 if(tidLeggeSeg <= 0)
 {
    tidsInterval = 0;
 }
 else
 {
  int antTimerIgjen;
  
  if(tidLeggeSeg == 22 || tidLeggeSeg == 23 || tidLeggeSeg == 24)
  {
    antTimerIgjen = tidLeggeSeg - 22;
  }
  else
  {
    antTimerIgjen = tidLeggeSeg + 2;
  }
  
  tidsInterval = antTimerIgjen * 3600000; 
  
 }
  


  


  // Setter de ulike tidsintervallene
  for(int i = 0; i > antLysrekker; i++)
  {
    intervaller[i] = (tidsInterval / antLysrekker) * (i+1);
  }
}
